IMPLEMENTATION MODULE AEI;
(*$S-,$T-,$Q+
    1986-2015 Ari.Tao  * 01.02.93 ~ 09.09.97 + 26.04.14 ~ 06.06.15
   Fr's TeDeum (mit Mini-GEMX linken!):                 .
IMPORT SYSTEM, (* Main,*) AEB, VT,VN, BIOX, GDB, SX, Aux;
*)
FROM   SYSTEM IMPORT ADR;
IMPORT CleanUp;

FROM   AEB  IMPORT
       UPDATE,CLR, CURRAREA,WORKSPAC, FORCE,BEE,ARR, MsgPipeR,
       ACCOPEN,ACCLOSE, WindGet,WindSet, WindSem, WindNew, aCmd,
       Global, ApplInit,ApplExit, ApplIsAcc,ApplName, ApplYielT,
       DeskNewTop,DeskRefresh, EventMessage,EventTimer,RsrcFree,
       MenuLatch,MenuRegist, GrafHandle,GrafMouseDef, ShellRead;

PROCEDURE AesTerm; BEGIN Exit END AesTerm; (* Exit kann als Vektor dienen!*)

PROCEDURE Init;
 BEGIN APID := ApplInit ();
       Exit := Exit0;
       CleanUp.Install (AesTerm);
       ClUpInstall  := CleanUp.Install;
       ClUpModTerm  := CleanUp.ModTerm;
       ClUpExValPtr := ADR (CleanUp.ExValue);
       ClUpPreTermP := ADR (CleanUp.PreTerm);
       isACC := ApplIsAcc ();
       onMGX := (Global.Version = 399H);
       onRTX := (Global.Count # 1);
   IF ~onRTX & isACC THEN NAME := "NN"; Cmd := ""; Tail := "";
   ELSE ApplName (NAME); ShellRead (Cmd, Tail); aCmd := ADR(Cmd) END;
   WindGet (0, WORKSPAC, X0,Y0, WMAX,HMAX);
   INC (WMAX, X0); XMAX := WMAX-1;
   INC (HMAX, Y0); YMAX := HMAX-1;
   NCPL := Global.nColPl;
   GDEV := GrafHandle (); END Init;

PROCEDURE Exit0;               (* Clients duty: Bei Prg.-Ende aufzurufen! *)
 BEGIN WindSem (CLR);
       GrafMouseDef (FORCE+BEE);
   IF  isACC THEN DeskRefresh; RETURN END;
   IF (0= MenuLatch (0)) THEN END;
(* DeskNewTop (0); no!!! *)
(* WindNew; *)
   RsrcFree;
   ApplExit;
   IF (Global.Version >= 363H) THEN RETURN END;
(* versuchsweise wg. ACCLOSEs: *)
   APID := ApplInit ();
   ApplYielT (21);
   ApplExit; END Exit0;

PROCEDURE RunAccPrg (VAR AccsMenu: ARRAY OF CHAR; MainLoop: PROC);
   VAR MenuId: INTEGER; Msg: MsgPipeR; pN: POINTER TO S20;
 BEGIN GrafMouseDef (FORCE+ARR);
       WindSem (CLR);
       IF ~isACC THEN (*PRG!*) MainLoop; RETURN END;
       MenuId := MenuRegist (APID, AccsMenu);
   IF (MenuId < 0) THEN IF onRTX THEN RETURN END;    (* else Dauerschlaf: *)
        LOOP EventTimer (MAX(INTEGER)) END;
   ELSE pN := ADR (AccsMenu) +2; NAME := pN^; NAME[20] := 0c END;
   LOOP WindSem (CLR);
        EventMessage (Msg);
     IF Msg.Type = ACCOPEN THEN MainLoop END;
     END (*Ananta*); END RunAccPrg;

(**)
BEGIN Init END AEI .                                                       .

   Das folgende TeDeum ist sowohl ein Muster-Bsp., das als .PRG, .ACC & .TOS
   luft, als auch ein ntzliches Tool (Environment-Check &c.):
*)

MODULE TESTandDEMO;
FROM SYSTEM IMPORT ADR, WORD, CODE, NULL;
FROM   AEB  IMPORT AD,LW,LI,IG,CD,BL, MEX,GRAY,MOCTRL, EventPause,FormAlert,
                   DeskCover,DeskRefresh, GrafMoKState,ShellWrite,ShellEnvV;
FROM   VT   IMPORT wT, Cur0, Ln,Fw, Home;
FROM   BIOX IMPORT aLAV, ConSt, ConCO, OwnIO;
FROM   GDB  IMPORT Syield;
IMPORT VN, SX, Aux, UPDATE,CLR, FORCE,ARR, ApplYielT,GrafMouseDef, WindSem,
       isACC, onMGX,onRTX, APID,NAME,GDEV, NCPL,WMAX,HMAX, Cmd,Tail, Global;
EXPORT TeDeum;

CONST  CR = 15c; FW = 'C'; BC = 'D'; ESC = 33c; NONE = "--- ";

PROCEDURE MyMoFa;                            (* Quadrtchen mit Zielkreuz.*)
 CONST LINK = 4E50H; (*$P-*)
 BEGIN CODE (7,7, 1,0,1);
       CODE (0FFFEH,7FFCH,4384H,4384H,4384H,0FC7EH,4004H, 0,
             4004H,0FC7EH,4384H,4384H,4384H,7FFCH,0FFFEH, 0);
       CODE (0FFFEH,8102H,8102H,8102H,8102H,8102H, 8002H,0FC7EH,
              8002H,8102H,8102H,8102H,8102H,8102H,0FFFEH, 0, LINK);
       END MyMoFa;   (*$P+*)

PROCEDURE Byield; BEGIN IF ConSt() THEN END END Byield;
(*
PROCEDURE OwnIO (): BOOLEAN;
   VAR pX: AD; X,Z: IG;
 BEGIN pX := aLAV -01CH;
(* Byield; ConCO (ESC); ConCO (BC); *)
   Syield; ConCO (CR);
   Syield; Z:= IG(pX^); WindSem (+UPDATE);
           ConCO (ESC); ConCO (FW);
   Syield; X:= IG(pX^); WindSem (-UPDATE);
(*     ^---- Fr koop. Genever nur mit Syield, nicht Byield! *)
   RETURN (X # Z); END OwnIO;
*)
PROCEDURE AeGlobalInfo;
   VAR i: IG; g: AD;
 BEGIN Ln; wT (" Global Array: "); g := ADR (Global);
   Ln; Fw; FOR i := 0 TO 14 DO VN.wDecW (i, 5) END;
   Ln; Fw; FOR i := 0 TO 14 DO VN.wHexW (g^,5); INC (g, 2) END;
   END AeGlobalInfo;

PROCEDURE ShellBufInfo;
 BEGIN Ln; wT (" Shell's Call: ");
       IF (Cmd[0] =0c) THEN wT (NONE); RETURN END;
       Fw; (* BIOX.RawSO *) wT (Cmd);
   Fw; Fw; (* BIOX.RawSO *) wT (Tail);
   END ShellBufInfo;

PROCEDURE ShellEnvAdr (): AD;
   VAR pE: AD; k: CD; e1: ARRAY [0..64] OF CHAR;
 BEGIN pE := ShellEnvV (""); k := 0;
   IF (pE = NULL) THEN e1 := "";                   (* Speziell fr N.AES! *)
       ShellWrite (8(*ENV*),2(*COPY*),64, e1, "");
       WHILE (k < 63) & (e1[k] # 0c) & (e1[k] # '=') DO INC (k) END;
       INC (k); e1[k] := 0c;
       pE := ShellEnvV (e1); END (*I*);
   IF (pE # NULL) THEN DEC (pE, k) END;
(* IF (pE = NULL) THEN pE := ShellEnvV ("PATH=") END; *)
   RETURN pE; END ShellEnvAdr;

PROCEDURE ShellEnvInfo;
   VAR pS: SX.PST;
 BEGIN Ln; wT (" Shell's Environment: ");
       Syield;
       pS := ShellEnvAdr ();   (* das Env., das die Shell selbst mitbekam.*)
(*     pS := Main.EnvA (0c);      das Env., das die Shell an das Prg. gab.*)
   IF (pS = NULL) THEN wT (NONE); Ln; RETURN END;
   WHILE   (pS^[0] # 0c) DO Ln; Fw; wT (pS^);
     WHILE (pS^[0] # 0c) DO INC (pS) END;
     INC (pS); END (*W*);
   END ShellEnvInfo;

PROCEDURE Infos;
   VAR ownIO: BL;
 BEGIN ownIO := OwnIO ();
   IF  ownIO THEN WindSem (+UPDATE+MOCTRL); GrafMouseDef (MEX);
     Home; Cur0;  Syield;
     DeskCover (ORD (~isACC), GRAY); END (*I*);
   AeGlobalInfo;
   ShellBufInfo;
   ShellEnvInfo;
   ApplYielT (-23);
   IF ~ownIO THEN RETURN END;
   GrafMouseDef (FORCE+ AD(MyMoFa));
   EventPause (0);
   GrafMouseDef (ARR);
   WindSem (CLR);
   IF onRTX OR isACC THEN DeskRefresh END;
   END Infos;

PROCEDURE Alert (DefBut: IG; VAR AlSt: ARRAY OF CHAR): IG;
   VAR Res, mx,my: IG;  Bs,Ks: BITSET;
 BEGIN ApplYielT (23);  (* Damit der Screen aufgerumt ist vor dem Alert! *)
       Res := ABS (FormAlert (DefBut, AlSt));
   GrafMoKState (mx,my, Bs,Ks); (* Macht Alert auch in .TOSsen benutzbar! *)
   IF ((Bs+Ks) # {}) THEN Res := -Res END;
   RETURN Res; END Alert;

PROCEDURE TeDeum;
   VAR AlSt: SX.STR;  s: SX.S40;
   PROCEDURE Add (VAR p: ARRAY OF CHAR; i: IG);
    BEGIN SX.Apd (AlSt, p); Aux.LItoSt (LONG(i), 5, s);
          SX.Apd (AlSt, s); END Add;
 BEGIN AlSt := "[0][ |  ";  SX.Apd (AlSt, NAME);
   Add (           " |              :  APID:", APID);
   Add (" |  GDEV:", GDEV); Add ("  :  NCPL:", NCPL);
   Add (" |  WMAX:", WMAX); Add ("  :  HMAX:", HMAX);
   SX.Apd (AlSt, "    ][  Info  | OK ]");
   LOOP CASE Alert (2, AlSt) OF 2: EXIT ELSE Infos END END;
   END TeDeum;

END (*M*) TESTandDEMO;

PROCEDURE Cite (VAR c: ARRAY OF CHAR); END Cite;

BEGIN Init; RunAccPrg ("  AE-Info ", TeDeum);
      Cite ("#  2015 ARI.TAO #");

(* Anscheinend erledigt (13.05.14):
   AEB.ApplExit;
      (* Vorlufiger Hack, um den 'Schluabsturz' unter MTOS zu vermeiden.*)
   GDB.Term (0);
*)
   END AEI .
